// include
//-------------------------------------
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include "share.h"
#include "gui.h"
#include "Log.h"


// constants
//--------------------------
const char*    CFG_LOG_FILE =       "hm2.log";


// globals
//--------------------------
sInitPDU             g_init_pdu;
Log                  g_log;
HINSTANCE            g_hinstance = NULL;


// prototypes
//--------------------------
extern bool    appStart( sInitPDU& pdu );
extern void    appStop( void );
bool __stdcall hackStart( sInitPDU& pdu );
void           hackStop( void );
bool           loadLog( void );
bool           print( const char* str, ... );


// init routines
//-------------------------------------
bool dllOpen( HINSTANCE instance )
{
   g_hinstance = instance;
   return true;
}

//-------------------------------------
void dllClose( void )
{
   hackStop();
}

//-------------------------------------
bool __stdcall hackStart( sInitPDU& pdu )
{
   memcpy((void*)&g_init_pdu, &pdu, sizeof(sInitPDU));
   if(!guiStart(g_init_pdu.gui_hwnd))
      return false;
   if(!loadLog())
      return false;
   print("loading");
   if(!appStart(pdu))
      return false;

   return true;
}

//-------------------------------------
void hackStop( void )
{
   appStop();
   print("unloading");
   guiStop();
   g_log.close();
}


// utility functions
//--------------------------
bool print( const char* str, ... )
{
   va_list  args;
   char     message[BUF_STRING_SIZE];

   va_start(args, str);
   vsprintf(message, str, args);
   va_end(args);

   guiPrint(message);
   g_log.print("%s\n", message);

   return true;
}

//--------------------------
static bool loadLog( void )
{
   static char path[BUF_STRING_SIZE];

   sprintf(path, "%s\\%s", g_init_pdu.path, CFG_LOG_FILE);
   g_log.setFileName(path);
   if(!g_log.open())
      return false;
   char date_buf[9];
   char time_buf[9];
   g_log.print("---(%s %s)-----------\n", _strtime(time_buf), _strdate(date_buf));

   return true;
}
