#pragma once

// constants
//--------------------------
#define OP_MAXSIZE         16
#define OP_BRANCH_SIZE     5
#define OP_JMP             0xe9
#define OP_CALL            0xe8
#define OP_NOP             0x90
#define OP_PUSHAD          0x60
#define OP_POPAD           0x61
#define OP_MOV_ADDR_REG    0x89
#define OP_MOV_REG_ADDR    0x8b
#define OP_MOV_ESP_CONST   0xbc

#define REG_ESP            0x25


// x86 support functions
//--------------------------
bool x86GetInstrBufferLength( const unsigned char* instr, unsigned int min_length, unsigned int& length );
bool x86GetInstrLength( const unsigned char* instr, unsigned int& length );
bool x86Relocate( const unsigned char* instr, unsigned int opcodes_length, unsigned int opcodes_address, unsigned char* target, int& target_length );