/*
   BUGS: some branches dont work quite right yet
*/
   
// include
//--------------------------
#include <assert.h>
#include <memory.h>
#include "x86.h"


// x86Relocate
//--------------------------
bool x86Relocate( const unsigned char* instr, unsigned int instr_length, unsigned int instr_address, unsigned char* target, int& target_length )
{
   const unsigned char*    instr_end;
   const unsigned char*    instr_start;

   target_length = 0;
   instr_start = instr;
   instr_end = instr + instr_length;
   while((unsigned int)instr < (unsigned int)instr_end)
   {
      int            presize = 0;
      int            branch_op = 0;
      unsigned int   length;

      // prefixes
      while(true)
      {
         switch(instr[presize])
         {
         case 0xf0:
         case 0xf2:
         case 0xf3:
         case 0x2e:
         case 0x36:
         case 0x3e:
         case 0x26:
         case 0x64:
         case 0x65:
         case 0x66:
         case 0x67:
            presize++;
            continue;
         }
         break;
      }

      // handle branch calls
      switch(instr[presize])
      {
      case 0x0f:
         switch(instr[presize])
         {
         case 0x80:
         case 0x81:
         case 0x82:
         case 0x83:
         case 0x84:
         case 0x85:
         case 0x86:
         case 0x87:
         case 0x88:
         case 0x89:
         case 0x8a:
         case 0x8b:
         case 0x8c:
         case 0x8d:
         case 0x8e:
         case 0x8f:
            branch_op = OP_JMP;
            presize+=2;
         };
         break;
      case 0x70:
      case 0x71:
      case 0x72:
      case 0x73:
      case 0x74:
      case 0x75:
      case 0x76:
      case 0x77:
      case 0x78:
      case 0x79:
      case 0x7a:
      case 0x7b:
      case 0x7c:
      case 0x7d:
      case 0x7e:
      case 0x7f:
      case 0xe3:
      case 0xe8:
      case 0xe9:
      case 0xeb:
         branch_op = OP_CALL;
         presize++;
         break;
      }

      // get length
      if(!x86GetInstrLength(instr, length))
         return false;

      // handle jump
      if(branch_op)
      {
         int            offset;
         unsigned int   offset_size;

         offset_size = length - presize;
         switch(offset_size)
         {
         case 1:
            offset = *(char *)&instr[presize];
            break;
         case 2:
            offset = *(short *)&instr[presize];
            break;
         case 4:
            offset = *(int *)&instr[presize];
            break;
         default:
            return false;
         }
         offset = ((unsigned int)(instr-instr_start)+length+offset+(unsigned int)instr_address) - ((unsigned int)target+OP_BRANCH_SIZE);
         target[0] = branch_op;
         *(int *)&target[1] = offset;
         target += OP_BRANCH_SIZE;
         target_length += OP_BRANCH_SIZE;
      }
      else
      {
         memcpy(target, instr, length);
         target += length;
         target_length += length;
      }
      instr += length;
   }

   return true;
}

